package main

import (
	"fmt"
	"net/http"
	"os"

	"github.com/gorilla/mux"
	httpSwagger "github.com/swaggo/http-swagger"

	// API demo https://www.soberkoder.com/swagger-go-api-swaggo/
	// Use https://github.com/swaggo/swag#declarative-comments-format to format REST API
	// pkg/endpoints/openapi folder is generated by Swag CLI, check readme.
	"go-common/components/utils/logger"
	"xnfrv/components/xnfv-api/pkg/endpoints"
	"xnfrv/components/xnfv-api/pkg/endpoints/openapi"
)

func init() {
	// Env variables are used to inject the IP to the Host annotation to connect swagger correctly
	// even in prod
	// To enable client behind tls ingress
	host := os.Getenv("SWAGGER_URL")
	logger.Log.Infof("Swagger info to %s\n", host)
	openapi.SwaggerInfo.Host = host
	openapi.SwaggerInfo.Schemes = []string{os.Getenv("SWAGGER_SCHEMA")}
	if os.Getenv("SWAGGER_BASE_PATH") != "" {
		openapi.SwaggerInfo.BasePath = os.Getenv("SWAGGER_BASE_PATH")
	}
}

// @title xNF Verification API
// @version 1.0
// @description Handles OCIDistributionNotifications from the xNF Registry to trigger scans and verification pipelines over 5G artifacts
// @termsOfService http://swagger.io/terms/
// @contact.name Guillermo Gomez
// @contact.url https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-Registry-Verification/
// @contact.email guillermo.gomezchavez@eviden.net
// @license.name Eviden (ATOS business) 2023
// @tag.name internal
func main() {
	r := mux.NewRouter()
	r.PathPrefix("/swagger").Handler(httpSwagger.WrapHandler)
	r.HandleFunc("/health", endpoints.Health).Methods("GET")
	r.HandleFunc("/notify", endpoints.Notify).Methods("POST")
	r.HandleFunc("/vreport", endpoints.GetReport).Methods("GET")
	r.HandleFunc("/configure", endpoints.Configure).Methods("GET")
	logger.Log.Infof("Finished configuring handlers. Serving on %s://%s%s/swagger/index.html\n", os.Getenv("SWAGGER_SCHEMA"), os.Getenv("SWAGGER_URL"), os.Getenv("SWAGGER_BASE_PATH"))
	// Block here
	logger.Log.Fatal(http.ListenAndServe(fmt.Sprintf(":%s", os.Getenv("SWAGGER_PORT")), r))

}
